{
  TLRDBItem
    TLRItemh
    f[^x[XΉR|[lg
    w肳ꂽf[^ڂ DisplayText ̓eZbg
  vpeB
    DataField: string  tB[h
    DataSource: TDataSource  f[^\[X

  TLRDBItemR
    TLRItemRh
    f[^x[XΉR|[lg̊pۑΉ
    w肳ꂽf[^ڂ DisplayText ̓eZbg
    pە\̃WbNGƎv߁ApۂȂR|ƂQނɂ
  vpeB
    DataField: string  tB[h
    DataSource: TDataSource  f[^\[X

  Ver1.00  TLRDBItem , TLRDBItemR gpĂꍇ DataSet  FieldName
  vpeBȂĂ܂B
  DataSource  DataField vpeBɐݒ肵ĂBm(__)m

}

{
  2000.09.07 LRSuppl  DBΉR|ʃjbgɂ
             ... DB ֘AgpȂꍇ .exe ̗eʂɔz邽

}
unit LRDBSpl;

interface

uses
  Windows, SysUtils, Classes, Graphics, LightRep, LRSuppl, Db, DBCtrls;

type
  // f[^x[XΉR|[lg
  TLRDBItem = class(TLRItem)
  private
    FDataLink: TFieldDataLink;
    function GetDataField: string;
    function GetDataSource: TDataSource;
    procedure SetDataField(const Value: string);
    procedure SetDataSource(const Value: TDataSource);
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure ActiveChange(Sender: TObject); virtual;
    procedure DataChange(Sender: TObject); virtual;
    procedure Print(ACanvas: TCanvas; ARect: TRect;
      APrintScale: Double; APrintStatus: TPrintStatus); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property DataField: string read GetDataField write SetDataField;
    property DataSource: TDataSource read GetDataSource write SetDataSource;
  end;

  // f[^x[XΉR|[lg(p)
  TLRDBItemR = class(TLRItemR)
  private
    FDataLink: TFieldDataLink;
    function GetDataField: string;
    function GetDataSource: TDataSource;
    procedure SetDataField(const Value: string);
    procedure SetDataSource(const Value: TDataSource);
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure ActiveChange(Sender: TObject); virtual;
    procedure DataChange(Sender: TObject); virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property DataField: string read GetDataField write SetDataField;
    property DataSource: TDataSource read GetDataSource write SetDataSource;
  end;

implementation

{ TLRDBItem }

constructor TLRDBItem.Create(AOwner: TComponent);
begin
  inherited;
  FDataLink := TFieldDataLink.Create;
  FDataLink.Control := Self;
  FDataLink.OnDataChange := DataChange;
  FDataLink.OnActiveChange := ActiveChange;
end;

destructor TLRDBItem.Destroy;
begin
  FDataLink.Free;
  inherited;
end;

procedure TLRDBItem.ActiveChange(Sender: TObject);
begin
  if  csDesigning in ComponentState  then  // ݌v̂݃tB[horOZbg
    begin
      if  not FDataLink.DataSet.Active  then
        if  FDataLink.FieldName = ''  then  Text := Name
        else  Text := FDataLink.FieldName;
    end;
end;

procedure TLRDBItem.DataChange(Sender: TObject);
var
  Field: TField;
begin
  if  FDataLink.FieldName <> ''  then
    begin
      Field := FDataLink.DataSet.FindField(FDataLink.FieldName);
      if  Assigned(Field)  then  Text := Field.DisplayText;
    end;
end;

procedure TLRDBItem.SetDataSource(const Value: TDataSource);
begin
  FDataLink.DataSource := Value;
end;

function TLRDBItem.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource;
end;

procedure TLRDBItem.SetDataField(const Value: string);
begin
  FDataLink.FieldName := Value;
  if  Value <> ''  then  Text := Value;
end;

function TLRDBItem.GetDataField: string;
begin
  Result := FDataLink.FieldName;
end;

procedure TLRDBItem.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;
  if  (Operation = opRemove) and (AComponent = FDataLink.DataSource)  then
    FDataLink.DataSource := nil;
end;

procedure TLRDBItem.Print(ACanvas: TCanvas; ARect: TRect;
  APrintScale: Double; APrintStatus: TPrintStatus);
begin
  inherited;
{  if  csDesigning in ComponentState  then
    DrowDesignFrame(ACanvas, Color, ARect,
      LineLeft, LineTop, LineRight, LineBottom);}
end;

{ TLRDBItemR }

constructor TLRDBItemR.Create(AOwner: TComponent);
begin
  inherited;
  FDataLink := TFieldDataLink.Create;
  FDataLink.Control := Self;
  FDataLink.OnDataChange := DataChange;
  FDataLink.OnActiveChange := ActiveChange;
end;

destructor TLRDBItemR.Destroy;
begin
  FDataLink.Free;
  inherited;
end;

procedure TLRDBItemR.ActiveChange(Sender: TObject);
begin
  if  not FDataLink.DataSet.Active  then
    if  FDataLink.FieldName = ''  then  Text := Name
    else  Text := FDataLink.FieldName;
end;

procedure TLRDBItemR.DataChange(Sender: TObject);
var
  Field: TField;
begin
  if  FDataLink.FieldName <> ''  then
    begin
      Field := FDataLink.DataSet.FindField(FDataLink.FieldName);
      if  Assigned(Field)  then  Text := Field.DisplayText;
    end;
end;

procedure TLRDBItemR.SetDataSource(const Value: TDataSource);
begin
  FDataLink.DataSource := Value;
end;

function TLRDBItemR.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource;
end;

procedure TLRDBItemR.SetDataField(const Value: string);
begin
  FDataLink.FieldName := Value;
  if  Value <> ''  then  Text := Value;
end;

function TLRDBItemR.GetDataField: string;
begin
  Result := FDataLink.FieldName;
end;

procedure TLRDBItemR.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;
  if  (Operation = opRemove) and (AComponent = FDataLink.DataSource)  then
    FDataLink.DataSource := nil;
end;

end.
