﻿{
  LightReport2 補充コンポ(Ver2.5.1)
                                 ... written by ohtaka(ohta@urban.ne.jp)

[ LRSuppl ユニット ]

  TLRItemR
    TLRItemから派生
    枠を角丸にするコンポーネント
    角丸の先の太さは RoundLeftTop, RoundRightTopが LineTop に
    RoundLeftBottom, RoundRightBottomが LineBottom に依存する
  プロパティ
    RoundSize: Integer  角の丸みの大きさ
    RoundLeftTop: Boolean  左上角丸
    RoundLeftBottom: Boolean  左下角丸
    RoundRightTop: Boolean  右上角丸
    RoundRightBottom: Boolean  右下角丸

[ LRDBSpl ユニット ]

  TLRDBItem
    TLRItemから派生
    データベース対応コンポーネント
    指定されたデータ項目から DisplayText の内容をセットする
  プロパティ
    DataField: string  フィールド名
    DataSource: TDataSource  データソース

  TLRDBItemR
    TLRItemRから派生
    データベース対応コンポーネントの角丸対応
    指定されたデータ項目から DisplayText の内容をセットする
    角丸表示のロジックが複雑と思うため、角丸を持たないコンポと２種類にした
  プロパティ
    DataField: string  フィールド名
    DataSource: TDataSource  データソース

  Ver1.00 の TLRDBItem , TLRDBItemR を使用されている場合 DataSet と FieldName
  プロパティが無くなっています。
  DataSource と DataField プロパティに設定し直してください。m(__)m


[ LRPrvSpl ユニット ]

  TLRPreviewControl
    プレビューコントロールコンポーネント

    プレビューで前後出来るように、リストに表示イメージを保存、管理します。
    プレビューを表示するフォームは持っていません、コントロールのみです。

    プロパティ、メソッドについては LRPrvSpl.txt を参照してください。
}

{
  2000.08.09 LRSuppl を新規作成
  2000.08.09 TLRItemR を追加
  2000.08.12 TLRDBItem TLRDBItemR を追加
             TLRSuppFieldProperty を追加
             プロパティエディタのためにライブラリパスに
             $(DELPHI)\Source\Toolsapi が必要
  2000.08.29 LRSuppl Ver1.00 として公開

  2000.08.31 角丸の微妙なずれ(右上と左下)を修正
             Transparent = True のときは角丸も塗らないように修正
  2000.09.05 TLRDBItem , TLRDBItemR を TFieldDataLink で DB に接続するように変更
             ... ＴＡＫさん のソースを参考にしました(感謝)
             プロパティエディタ(TLRSuppFieldProperty)は不要になったので削除
             ライブラリパスの$(DELPHI)\Source\Toolsapi も不要
  2000.09.05 LRSuppl Ver1.10 として公開

  2000.09.07 サンプルプログラムに TPrintMsgU が残っていたのを削除
  2000.09.07 LRSuppl Ver1.11 として公開

  2000.09.07 LRSuppl から DB対応コンポを別ユニット(LRDBSpl) にした
             ... DB 関連を使用しない場合の .exe の容量に配慮するため
  2000.09.15 紆余曲折を経てTLRPreviewControl を作成

  2001.08.25 Delphi6 に対応
  2001.08.27 LRSuppl Ver2.01 として公開
}
unit LRSplReg;

interface

uses  Classes, LRSuppl, LRDBSpl, LRPrvSpl;

//  type

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('LightReport2', [TLRItemR, TLRDBItem, TLRDBItemR,
    TLRPreviewControl]);
end;

end.
