{
  TLRPreviewControl
    vr[Rg[R|[lg
    vr[őOo悤ɁAXgɕ\C[WۑAǗ܂B
    vr[\tH[͎Ă܂ARg[݂̂łB
}

{
  2000/09/15 ]Ȑ܂oĐVK쐬
  2001/10/17 vr[\̐FȂsC
  2001/10/25 vr[C[W̕ۑ TNkDIB gp悤ύX
             ZLib ͕svɂȂ܂
             ATNkDIB ɂgp̏ꍇ͖肪܂ tnkdib.txt
             QƂĂ
  2001/10/26 vr[\Fɑ傫E邽 PixelFormat
             vpeBǉ
             \C[W̕ۑ TMemoryStream  TFileStream ɕύX
             SmallPreview ̏ꍇ\C[Wɕy[W\o邽
             PageNumber Ŏwł ShowPageNumber\bhǉ
             PageNumbervpeB͂₱Ȃ̂ PagevpeBɕύX
  2003/05/12 [No^^;
             Destroy ̒̈ȉ 2_C
             FBitmapList.Clear;  -> FBitmapList.Free;
             FPageNumList.Clear; -> FPageNumList.Free;
}

unit LRPrvSpl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, ExtCtrls, LightRep, NkDIB;

type
  // vr[Rg[R|[lg
  TLRPreviewControl = class(TComponent)
  private
    { Private 錾 }
    FLightRep: TLightRep;
    FBitmapList, FPageNumList: TList;
    FBitmap: TBitmap;
    FPixelFormat: TPixelFormat;
    FIndex: Integer;
    FImage: TImage;
    FBitmapFileName: string;
    FBitmapStream: TFileStream;
    function GetPage: Integer;
    function GetBop: Boolean;
    function GetEop: Boolean;
    function GetTotalPages: Integer;
    function UniqueTempFileName: string;
    procedure SetLightRep(const Value: TLightRep);
    procedure CreateFCanvas;
  protected
    { protected 錾 }
    function AddImage(ABitmap: TBitmap): Integer;
    function AddBitmapListIndex: Integer;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure ShowImage(AIndex: Integer);
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Next: Boolean;
    procedure BeginPreview(Image: TImage);
    procedure EndPreview;
    procedure Preview;
    procedure Prior;
    procedure ShowPageNumber(APageNumber: Integer);
    procedure ShowPage(AIndex: Integer);
    procedure ShowFirstPage;
    procedure ShowLastPage;
    procedure SmallPreview(X, Y: Integer; Scale: Integer);
    procedure SmallPreviewSuspend;
    procedure ThreadPreview;
    procedure ThreadSmallPreview(X, Y: Integer; Scale: Integer);
    procedure ThreadSmallPreviewSuspend;
    property Index: Integer read FIndex;
    property Page: Integer read GetPage;
    property TotalPages: Integer read GetTotalPages;
    property Bop: Boolean read GetBop;
    property Eop: Boolean read GetEop;
  published
    { Published 錾 }
    property LightRep: TLightRep read FLightRep write SetLightRep;
    property PixelFormat: TPixelFormat read FPixelFormat write FPixelFormat default pf8bit;
  end;

implementation

{ TLRPreviewControl }

constructor TLRPreviewControl.Create(AOwner: TComponent);
begin
  inherited;
  //  l 256FƂ
  FPixelFormat := pf8bit;
  //  TNkDIB Xg[ɕۊǂJnAhXL^
  FBitmapList := TList.Create;
  //  PageNumber ܂FBitmapListIndexL^
  FPageNumList := TList.Create;
end;

destructor TLRPreviewControl.Destroy;
var
  i: Integer;
begin
  for  i := FBitmapList.Count - 1 downto 0  do
    Dispose(FBitmapList[i]);
  FBitmapList.Free;
  for  i := FPageNumList.Count - 1 downto 0  do
    Dispose(FPageNumList[i]);
  FPageNumList.Free;
  if  Assigned(FBitmapStream)  then
    begin
      FBitmapStream.Destroy;
      DeleteFile(FBitmapFileName);
    end;
  if  Assigned(FBitmap)  then  FBitmap.Free;
  inherited;
end;

procedure TLRPreviewControl.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;
  if  (Operation = opRemove) and (AComponent = FLightRep)  then
    LightRep := nil;
end;

procedure TLRPreviewControl.CreateFCanvas;
begin
  // w肳ꂽFŃvr[p Bitmap 쐬
  if  not Assigned(FBitmap)  then
    begin
      FBitmap := TBitmap.Create;
      FBitmap.PixelFormat := FPixelFormat;  // F̎w
      FBitmap.Height := FImage.Height;
      FBitmap.Width := FImage.Width;
    end;
  with  FBitmap.Canvas  do
  begin
    Brush.Color := clWhite;
    FillRect(Rect(0, 0, FBitmap.Width - 1, FBitmap.Height - 1));
  end;
end;

procedure TLRPreviewControl.BeginPreview(Image: TImage);
var
  i: Integer;
begin
  //  Õvr[̌n
  for  i := FBitmapList.Count - 1 downto 0  do
    Dispose(FBitmapList[i]);
  FBitmapList.Clear;
  for  i := FPageNumList.Count - 1 downto 0  do
    Dispose(FPageNumList[i]);
  FPageNumList.Clear;
  //  ꎞt@C폜
  if  Assigned(FBitmapStream)  then
    begin
      FBitmapStream.Destroy;
      DeleteFile(FBitmapFileName);
    end;
  // Tempt@C̎擾
  FBitmapFileName := UniqueTempFileName;
  //  C[Wۑp̈ꎞt@Cm
  //  VXeTemptH_ vLR[A].txt ̌`ō쐬
  FBitmapStream := TFileStream.Create(FBitmapFileName,
    fmCreate or fmShareExclusive);
  //  vr[p̑Os
  FImage := Image;
  CreateFCanvas;
  LightRep.BeginPreview;
end;

procedure TLRPreviewControl.EndPreview;
begin
  LightRep.EndPreview;
end;

function TLRPreviewControl.AddImage(ABitmap: TBitmap): Integer;
var
  TempNkDIB: TNkDIB;
  pPos: ^Integer;
begin
  //  \pɕ`悵ARLEk(NkDIB)ĕۊ
  TempNkDIB := TNkDIB.Create;
  try
    TempNkDIB.Assign(ABitmap);
    try
    if  FPixelFormat = pf4Bit  then
      TempNkDIB.PixelFormat := nkPf4BitRLE
    else
      TempNkDIB.PixelFormat := nkPf8BitRLE;
    except
      on ENkDIBCompressionFailed  do
    end;
    //  CXbhvꍇPosition̂ōŌɈʒuÂ
    FBitmapStream.Position := FBitmapStream.Size;
    New(pPos);
    pPos^ := FBitmapStream.Position;
    TempNkDIB.SaveToStream(FBitmapStream);
    Result := FBitmapList.Add(pPos);
  finally
    TempNkDIB.Free;
  end;
end;

function TLRPreviewControl.AddBitmapListIndex: Integer;
var
  pPos: ^Integer;
begin
  New(pPos);
  pPos^ := FBitmapList.Count;
  Result := FPageNumList.Add(pPos);
end;

procedure TLRPreviewControl.ShowImage(AIndex: Integer);
var
  TempNkDIB: TNkDIB;
begin
  //  ۊǂĂ摜𓀂ĕ\pɕ`
  TempNkDIB := TNkDIB.Create;
  try
    FBitmapStream.Position := Integer(FBitmapList[AIndex]^);
    TempNkDIB.LoadFromStream(FBitmapStream);
    FImage.Picture.Graphic := TempNkDIB;
    FIndex := AIndex;
  finally
    TempNkDIB.Free;
  end;
end;

function TLRPreviewControl.GetPage: Integer;
begin
  Result := FIndex + 1;
end;

function TLRPreviewControl.GetTotalPages: Integer;
begin
  Result := FBitmapList.Count;
end;

function TLRPreviewControl.Next: Boolean;
begin
  //  ̃y[Wx\ĂۊǃXg\
  Result := (FBitmapList.Count - 1) > FIndex;
  if  Result  then
    begin
      Inc(FIndex);
      ShowImage(FIndex);
    end;
end;

procedure TLRPreviewControl.Preview;
begin
  //  ̃y[W߂Ă̕\̏ꍇ LightReport2ɕ`肢ĕۊǂ
  if  not Next  then
    begin
      LightRep.Preview(FBitmap.Canvas);
      AddBitmapListIndex;
      ShowImage(AddImage(FBitmap));
    end;
end;

procedure TLRPreviewControl.Prior;
begin
  //  Õy[WۊǃXg\
  if  FIndex > 0  then
    begin
      Dec(FIndex);
      ShowImage(FIndex);
    end;
end;

procedure TLRPreviewControl.SetLightRep(const Value: TLightRep);
begin
  FLightRep := Value;
end;

procedure TLRPreviewControl.SmallPreview(X, Y, Scale: Integer);
begin
  //  k\̏ꍇ͂Py[W̋؂̓AvP[VŔf
  //  ł̓TlCP̕`̂
  LightRep.ScaledPreview(FBitmap.Canvas, X, Y, Scale, FPixelFormat);
  FImage.Picture.Graphic := FBitmap;
  FImage.Repaint;
  AddBitmapListIndex;
end;

procedure TLRPreviewControl.SmallPreviewSuspend;
begin
  //  y[W؂ŃXgɕۊǂ
  ShowImage(AddImage(FBitmap));
  //  `pCanvas č쐬
  CreateFCanvas;
end;

// Xbhp̃vr[
procedure TLRPreviewControl.ThreadPreview;
begin
  LightRep.Preview(FBitmap.Canvas);
  AddBitmapListIndex;
  AddImage(FBitmap);
end;

// Xbhp̏kvr[
procedure TLRPreviewControl.ThreadSmallPreview(X, Y, Scale: Integer);
begin
  //  k\̏ꍇ͂Py[W̋؂̓AvP[VŔf
  //  ł̓TlCP̕`̂
  LightRep.ScaledPreview(FBitmap.Canvas, X, Y, Scale, FPixelFormat);
  AddBitmapListIndex;
end;

// Xbhp̏kvr[ꎞ~
procedure TLRPreviewControl.ThreadSmallPreviewSuspend;
begin
  //  y[W؂ŃXgɕۊǂ
  AddImage(FBitmap);
  //  `pCanvas č쐬
  CreateFCanvas;
end;

function TLRPreviewControl.GetBop: Boolean;
begin
  //  ŏ̃y[W
  Result := FIndex = 0;
end;

function TLRPreviewControl.GetEop: Boolean;
begin
  //  XgɓĂŏĨy[W
  Result := (FBitmapList.Count = 0) or ((FBitmapList.Count - 1) = FIndex);
end;

procedure TLRPreviewControl.ShowPageNumber(APageNumber: Integer);
begin
  //  ۊǃXgwy[W\
  if  (APageNumber < 1) or (APageNumber > FPageNumList.Count)  then
    Beep
  else
    begin
      FIndex := Integer(FPageNumList[APageNumber - 1]^);
      ShowImage(FIndex);
    end;
end;

procedure TLRPreviewControl.ShowPage(AIndex: Integer);
begin
  //  ۊǃXgwy[W\
  if  (AIndex < 1) or (AIndex > FBitmapList.Count)  then
    Beep
  else
    begin
      FIndex := AIndex - 1;
      ShowImage(FIndex);
    end;
end;

procedure TLRPreviewControl.ShowFirstPage;
begin
  ShowPage(1);
end;

procedure TLRPreviewControl.ShowLastPage;
begin
  ShowPage(FBitmapList.Count);
end;

function TLRPreviewControl.UniqueTempFileName: string;
var
  i: Integer;
  TmpPath, TmpFileName: string;
begin
  // Tempt@C̎擾
  // DelphiML ɂČ˓c pv񂩂炲܂()
  i := 1;
  Result := '';
  while  Result = ''  do
  begin
    SetLength(TmpPath, MAX_PATH - 12);
    SetLength(TmpFileName, MAX_PATH + 1);
    GetTempPath(Length(TmpPath), PChar(TmpPath));
    GetTempFileName(PChar(TmpPath), 'vLR', i, PChar(TmpFileName));
    SetLength(TmpFileName, StrLen(PChar(TmpFileName)));
    if  FileExists(TmpFileName)  then    // ݃`FbN
      if  DeleteFile(TmpFileName)  then  // r[hŊJĂ̂ō폜oȂ
        Result := TmpFileName            // 폜oꍇ͋IȂǂŃ[Nt@C
      else                               // cĂ̂Ƃăt@C𗘗p
    else
      Result := TmpFileName;
    Inc(i);
  end;
end;

end.
