﻿unit LRVer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, DesignEditors, LRConsts;

type
  TLRVerForm = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    Label3: TLabel;
    Button1: TButton;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private 宣言 }
  public
    { Public 宣言 }
  end;

  // TLightRepのバージョン情報フォーム
  TLightRepVer = class(TDefaultEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

var
  LRVerForm: TLRVerForm;

implementation

{$R *.DFM}

procedure TLRVerForm.Button1Click(Sender: TObject);
begin
  Close;
end;

function TLightRepVer.GetVerbCount: Integer;
begin
  Result := 1;
end;

function TLightRepVer.GetVerb(Index: Integer): string;
begin
  if Index = 0 then
    Result := LIGHTREP_ABOUTBOX_TEXT
  else Result := '';
end;

procedure TLightRepVer.ExecuteVerb(Index: Integer);
begin
  if Index = 0 then
    with TLRVerForm.Create(Application) do
    try
      Caption := LIGHTREP_ABOUTBOX_TEXT;
      Label1.Caption := LIGHTREP_TITLE_TEXT;
      Label2.Caption := 'Version ' + LIGHTREP_VERSION_TEXT;
      Label3.Caption := LIGHTREP_COPYRIGHT_TEXT1;
      Label4.Caption := LIGHTREP_COPYRIGHT_TEXT2;
      Label5.Caption := LIGHTREP_DESCRIPTION;
      ShowModal;
    finally
      Free;
    end;
end;

end.